#include "robbolito.h"
#include <time.h>
#include "monitor.h"

static sint64 SEND;
static sint64 TIME_ABSOLUTE_, TIME_DESIRED, INCREMENT;
static int ABYSS;
static bool ALT;
void search_alt( int tr )
    {
    ALT = TRUE;

    if( jump_ok )
        longjmp(J, 1);
    }
void notify( sint64 x )
    {
    uint64 t, nps, NODES = move_white_number + move_black_number + move_null_number;
    clock_t u = clock_();

    SEND = x;
    t = x / 1000;

    if( t == 0 )
        nps = 0;
    else
        nps = NODES / t;
    u = clock_() - MOMENT;
    PRINTF("info time %I64d nodes %I64d nps %d cpuload %d\n",
        t, NODES, nps * 1000,(int) ((double) u / (double) x * 1000.0));
    FFLUSH();
    }

static sint64 TIME_BATTLE, TIME_EASY, TIME_ORDINARY;
void resolve_term( int d )
    {
    sint64 x;

    if( !jump_ok )
        return;

    x = clock_() - CLOCK;
    node_count = node_frequency;

    if( d == ABYSS )
        search_alt(1);

    if( x - SEND > 1000000 )
        notify(x);

	if( x > TIME_ABSOLUTE_ )
		search_alt(1);

	if( d >= 0 && d < 8 )
		goto END;

    if( !MOVE_BAD && x >= TIME_BATTLE )
        search_alt(2);

    if( EASY && x >= TIME_EASY )
        search_alt(3);

    if( !MOVE_BATTLE && x >= TIME_ORDINARY && !MOVE_BAD )
        search_alt(4);
    END:
    while( question_input() )
        input_console();
    }

#define Infinite 0xfffffffffffffff
#define STRTOK(p) p = strtok (NULL, " ")

void search_initialization( char *str )
    {
    char *p;
    sint64 time_white = Infinite, time_black = Infinite, increase_white = 0, increase_black = 0, TIME, movestogo = 0;
    ABYSS = 255;
    TIME_ABSOLUTE_ = TIME_DESIRED = Infinite;
    ALT = FALSE;
    SEND = 0;
    node_count = node_frequency = 4096;
    p = strtok(str, " ");

    for ( STRTOK(p); p != NULL; STRTOK(p) )
        {
        if( !strcmp(p, "depth") )
            {
            STRTOK(p);
            ABYSS = MAXIMUM(1, _atoi64(p));
            }
        else if( !strcmp(p, "movetime") )
            {
            STRTOK(p);
            TIME_ABSOLUTE_ = MAXIMUM(1, _atoi64(p)) * 1000;
            }
        else if( !strcmp(p, "wtime") )
            {
            STRTOK(p);
            time_white = _atoi64(p) * 1000;
            }
        else if( !strcmp(p, "winc") )
            {
            STRTOK(p);
            increase_white = _atoi64(p) * 1000;
            }
        else if( !strcmp(p, "btime") )
            {
            STRTOK(p);
            time_black = _atoi64(p) * 1000;
            }
        else if( !strcmp(p, "binc") )
            {
            STRTOK(p);
            increase_black = _atoi64(p) * 1000;
            }
        else if( !strcmp(p, "movestogo") )
            {
            STRTOK(p);
            movestogo = _atoi64(p);
            }

        else if( !strcmp(p, "infinite") )
            continue;

        else
            ERROR_("go string: %s", p);
        }
    TIME_BATTLE = Infinite;
    TIME_ORDINARY = Infinite;
    TIME_EASY = Infinite;
    TIME = POSITION.white_en_move ? time_white : time_black;

    if( TIME == Infinite )
        goto END;
    INCREMENT = POSITION.white_en_move ? increase_white : increase_black;

    if( movestogo )
        {
        if( movestogo > 25 )
            movestogo = 25;
        TIME_DESIRED = TIME / movestogo + INCREMENT;
        TIME_ABSOLUTE_ = (TIME * movestogo) / (2 * movestogo - 1) - MINIMUM(1000000, TIME / 10);

        if( TIME_ABSOLUTE_ < 5000 )
			TIME_ABSOLUTE_ = 5000; 
        }
    else
        {
        TIME_ABSOLUTE_ = TIME / 2 - 10000;

        if( TIME_ABSOLUTE_ < 5000 )
			TIME_ABSOLUTE_ = 5000; 
        TIME_DESIRED = TIME_ABSOLUTE_ / 22 + INCREMENT;
        }

    if( TIME_DESIRED > TIME_ABSOLUTE_ )
        TIME_DESIRED = TIME_ABSOLUTE_;

    if( TIME_DESIRED < 5000 )
		TIME_DESIRED = 5000; 

#if 1

    TIME_EASY = TIME_DESIRED / 4;
    TIME_BATTLE = TIME_DESIRED;
    TIME_ORDINARY = (3 * TIME_DESIRED) / 4;
#else

    TIME_EASY = TIME_DESIRED / 4;
    TIME_BATTLE = TIME_DESIRED;
    TIME_ORDINARY = (1 * TIME_DESIRED) / 2;

#endif

    END:
    if( TIME == Infinite )
        ANALYSIS = TRUE;
    else
        ANALYSIS = FALSE;
    }
